local vp_otp "vivprop c_hip c_vp d_dna d_vp viv valor_vp dhip dhip_vp dhip_otp deuda_hip deuda_hip_vp deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3 vp otp a_auto"   
local dfV "Est* df_VPri df_VPri1M df_VSec df_VSec1M df_Vall df_V1Mall"
local vlV "ing rda debt_pi_ratio rci_pend_75 numh edad hombre_casado genero instituto universidad unemp_sect sexo educ_ecf quintile_h" 
local Bv "i*Fin cf_B* d_B* cf_R* d_R* PV1*xA* m_xA* Ideu* Hip_* RenMo* Hbancofin_*" // act_tot_* roa_*
foreach yr of numlist 11 14 17 {
use  "$path4b\\EFH_ECF_all.dta", clear
egen deuda_hip = rowtotal(deuda_hip_*)
g c_hip = ( deuda_hip >0 & deuda_hip<.)
keep if a1==1
keep if year_efh==20`yr'
capture drop folio_20*
rename folio_efh folio_20`yr'
keep folio_20`yr' ${factor`yr'} factor_all `vp_otp' `dfV' `vlV' `Bv'
order folio ${factor`yr'} factor_all, first
save "$path4b\\EFH_ECF_`yr'.dta", replace
} 
//  //    //
use "$path_bs_do\EFH_2014_08\EFH_14_allvars.dta", clear
capture drop a1
g a1=(ord==1)
keep if a1==1
keep folio folio_2011
rename folio folio_2014
save "$path4b\efhPanel_14.dta", replace
keep if folio_2011<.
drop if folio_2011==0
joinby folio_2011 using "$path4b\\EFH_ECF_11.dta", unmatched(master) update
tab _merge
drop _merge
foreach var of varlist sexo-Estrato_OTP deuda_hip c_hip {
rename `var' Yr0_`var'
}
joinby folio_2014 using "$path4b\\EFH_ECF_14.dta", unmatched(master) update
tab _merge
drop _merge
foreach var of varlist sexo-Estrato_OTP deuda_hip c_hip {
rename `var' Yr1_`var'
}
drop folio_2011
rename folio_2014 folio_efh
g year_efh=2014
order folio_efh year_efh factor*, first
save "$path4b\efhPanel_11_14.dta", replace
tab year_efh

use "$path0\2017\EFH_17_allvars.dta", clear
capture drop a1
g a1=(ord==1)
keep if a1==1
keep if folio_2014<.
keep folio folio_2014
rename folio folio_2017
joinby folio_2014 using "$path4b\\EFH_ECF_14.dta", unmatched(master) update
tab _merge
drop _merge
foreach var of varlist sexo-Estrato_OTP c_hip {
rename `var' Yr0_`var'
}
joinby folio_2017 using "$path4b\\EFH_ECF_17.dta", unmatched(master) update
tab _merge
drop _merge
foreach var of varlist sexo-Estrato_OTP deuda_hip c_hip {
rename `var' Yr1_`var'
}
drop folio_2014
rename folio_2017 folio_efh
g year_efh=2017
order folio_efh year_efh factor*, first
save "$path4b\efhPanel_14_17.dta", replace 
joinby folio_efh year_efh using "$path4b\efhPanel_11_14.dta", unmatched(both) update
tab _merge
drop _merge
sort year_efh folio_efh 
save "$path4b\efhPanel_11_14_17.dta", replace
tab year_efh
