clear
import excel "$path4b\\uf_ts_vs2.xls", sheet("ExportCuadro") firstrow
rename U UFm
drop if UFm==.
g year=year(Periodo)
g month=month(Periodo)
drop C Periodo
save "$path4b\\TSuf.dta", replace
clear
import excel "$path4b\\ts_rpm_vs2.xls", sheet("ExportCuadro") firstrow
rename TasadepolíticamonetariaT MPRate
rename Tasadeinterésdelafacilid DiscountMPRate
rename D DepositMPRate
drop if MPRate==.
g year=year(Periodo)
g month=month(Periodo)
sum year month Periodo
drop E Periodo
save "$path4b\\TSmpr.dta", replace
clear
import excel "$path4b\\tasa_interbancaria_vs2.xls", sheet("ExportCuadro") firstrow
rename Tasadeinteréspromediointe RinterBank
drop if RinterBank==.
g year=year(Periodo)
g month=month(Periodo)
sum year month Periodo
drop C Periodo
save "$path4b\\TSRates.dta", replace
save "$path4b\\TSinterBank.dta", replace
clear
import excel "$path4b\\tasa_vivienda1_vs2.xls", sheet("ExportCuadro") firstrow // Tasa y flujo de colocación promedio vivienda 
drop if Viviendatasa==. // (tasas anuales reajustables en UF, miles de millones de pesos): más de 3 años
g year=year(Periodo)
g month=month(Periodo)
sum year month Periodo
drop D Periodo
joinby year month using "$path4b\\TSRates.dta", unmatched(both) update
tab _merge
drop _merge
rename Viviendatasa Rmortgage
g spread=Rmortgage-RinterBank
sum spread, d
g sp_max=r(max)
replace sp_max=sp_max+RinterBank
reg Rmortgage RinterBank year i.(month)  
predict rmp, xb
reg Rmortgage RinterBank year i.(year month) 
predict rmp2, xb
replace rmp=max(rmp,rmp2,sp_max)
replace Rmortgage=rmp if Rmortgage==.
sort year month
order year month, first
drop rmp rmp2 spread sp_max Viviendaflujo RinterBank
drop if year==2020 & month==2
sum Rmortgage if _n<=18  // values before Asian crisis
replace Rmortgage = min(Rmortgage, r(min)) if year<2002 // imputed values for before 2002
replace Rmortgage=Rmortgage/100   //  Put in number (0.01) instead of percentage (1%)
save "$path4b\\TSRates.dta", replace
