use "$path0\2007\Data\Base_trabajo\EFH_07_allvars.dta", clear
g folio_efh=folio
g year_efh=2007
keep if a1==1   //sum e17* e10* e44a*1 e44a*2 e44a*3 e36*1 e36*2 e36*3
g Ideuda_vp = e17 if e17>1000  // I is for inicial
g Id_vp_tr=e17tr if e17tr<90
recode Id_vp_tr 1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000  //Recode tramo in UF 
forv k=1/3 { 
g Ideuda_otp`k' = e44a_tp`k' if e44a_tp`k'>1000
g Id_otp`k'_tr = e44atr_tp`k' if e44atr_tp`k'<90
recode Id_otp`k'_tr 1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000
}
keep folio_efh year_efh dhip_vp deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3 Id* d_dna dhip dhip_vp dhip_otp d_dt vp otp c_vp c_otp vp otp
save "$path4b\\data_temp.dta", replace

use "$path0\2008\Data\Base_trabajo\EFH_08_allvars.dta", clear
g folio_efh=folio
g year_efh=2008
keep if a1==1
g Ideuda_vp = e9 if e9>1000  // I is for inicial
g Id_vp_tr=e9tr if e9tr<90
recode Id_vp_tr 1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000  //Recode tramo in UF 
forv k=1/3 { 
g Ideuda_otp`k' = e35a_tp`k' if e35a_tp`k'>1000
g Id_otp`k'_tr = e35atr_tp`k' if e35atr_tp`k'<90
recode Id_otp`k'_tr 1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000
}
keep folio_efh year_efh  dhip_vp deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3 Id* d_dna dhip dhip_vp dhip_otp d_dt vp otp c_vp c_otp vp otp
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace

use "$path0\2009\Data\Base_trabajo\EFH_09_allvars.dta", clear
g folio_efh=folio
g year_efh=2009
keep if a1==1
g Ideuda_vp = e9 if e9>1000  // I is for inicial
g Id_vp_tr=e9tr if e9tr<90  //1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000  //Recode tramo in UF
recode Id_vp_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=8500
forv k=1/3 { 
g Ideuda_otp`k' = e35a_tp`k' if e35a_tp`k'>1000
g Id_otp`k'_tr = e35atr_tp`k' if e35atr_tp`k'<90  //1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000
recode Id_otp`k'_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=8500
}
keep folio_efh year_efh  dhip_vp deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3 Id* d_dna dhip dhip_vp dhip_otp d_dt vp otp c_vp c_otp vp otp
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace

use "$path0\2010\Data\Base_trabajo\EFH_10_allvars.dta", clear
g folio_efh=folio
g year_efh=2010
keep if a1==1 
g Ideuda_vp = e18_p if e18_p>1000  // I is for inicial
g Id_vp_tr=e18_t if e18_t<90  //1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000  //Recode tramo in UF
recode Id_vp_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=8500
replace Id_vp_tr = e18_uf if Id_vp_tr==. & e18_uf>10
forv k=1/3 { 
g Ideuda_otp`k' = e50_h_p_`k' if e50_h_p_`k'>1000
if `k'==1 { 
g Id_otp`k'_tr = e50_h_t if e50_h_t<90  
recode Id_otp`k'_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=8500
replace Id_otp`k'_tr=e50_h_uf if Id_otp`k'_tr==. & e50_h_uf>10
}
}
keep folio_efh year_efh dhip_vp deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3 Id* d_dna dhip dhip_vp dhip_otp d_dt vp otp c_vp c_otp vp otp
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace

use "$path0\2011\Data\Base_trabajo\EFH_11_allvars.dta", clear
g folio_efh=folio
g year_efh=2011
keep if a1==1  // e56_a* e56_m* e28_a* e28_m* 
g Ideuda_vp = e19_p if e19_p>1000  // I is for inicial
g Id_vp_tr=e19_t if e19_t<90  //1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000  //Recode tramo in UF
recode Id_vp_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=7250 11=9000 12=10750 13=13750 14=17500 15=22500 16=35000
replace Id_vp_tr = e19_uf if Id_vp_tr==. & e19_uf>10
forv k=1/3 { 
g Ideuda_otp`k' = e48_h_p_`k' if e48_h_p_`k'>1000
g Id_otp`k'_tr = e48_h_t_`k' if e48_h_t_`k'<90  
recode Id_otp`k'_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=7250 11=9000 12=10750 13=13750 14=17500 15=22500 16=35000
replace Id_otp`k'_tr=e48_h_uf_`k' if Id_otp`k'_tr==. & e48_h_uf_`k'>10
}
keep folio_efh year_efh  dhip_vp deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3 Id* d_dna dhip dhip_vp dhip_otp d_dt vp otp c_vp c_otp vp otp 
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace

use "$path_bs_do\EFH_2014_08\EFH_14_allvars.dta", clear
capture drop a1
g a1=(ord==1)
g folio_efh=folio
g year_efh=2014
keep if a1==1
g Ideuda_vp = e19_p if e19_p>1000  // I is for inicial
g Id_vp_tr=e19t if e19t<90  //1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000  //Recode tramo in UF
recode Id_vp_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=7250 11=9000 12=10750 13=13750 14=17500 15=22500 16=35000
replace Id_vp_tr = e19_uf if Id_vp_tr==. & e19_uf>10
forv k=1/3 { 
g Ideuda_otp`k' = e56_pesos_`k' if e56_pesos_`k'>1000
g Id_otp`k'_tr = e56t_`k' if e56t_`k'<90  
recode Id_otp`k'_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=7250 11=9000 12=10750 13=13750 14=17500 15=22500 16=35000
replace Id_otp`k'_tr=e56_uf_`k' if Id_otp`k'_tr==. & e56_uf_`k'>10
}
keep folio_efh year_efh Id* d_dna d_vp d_otp d_tothip act_vp* act_otp* d_chvp d_otp* d_dt
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
capture drop _merge
save "$path4b\\data_temp.dta", replace

use "$path0\2017\EFH_17_allvars.dta", clear
capture drop a1
g a1=(ord==1)
g folio_efh=folio
g year_efh=2017
keep if a1==1
g Ideuda_vp = e15_p if e15_p>1000  // I is for inicial
g Id_vp_tr=e15t if e15t<90  //1=300 2=900 3=1500 4=2100 5=2700 6=3300 7=3900 8=4500 9=5400 10=8000  //Recode tramo in UF
recode Id_vp_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=7250 11=9000 12=10750 13=13750 14=17500 15=22500 16=35000 17=50000
replace Id_vp_tr = e15_uf if Id_vp_tr==. & e15_uf>10
forv k=1/3 { 
g Ideuda_otp`k' = e57_pesos_`k' if e57_pesos_`k'>1000
replace Ideuda_otp`k' = e57_`k' if Ideuda_otp`k'==. & e57_`k'>1000
g Id_otp`k'_tr = e57t_`k' if e57t_`k'<90  
recode Id_otp`k'_tr 1=125 2=375 3=750 4=1250 5=1750 6=2250 7=3100 8=4350 9=5750 10=7250 11=9000 12=10750 13=13750 14=17500 15=22500 16=35000 17=50000
replace Id_otp`k'_tr=e57_uf_`k' if Id_otp`k'_tr==. & e57_uf_`k'>10
}
keep folio_efh year_efh Id* d_dna d_vp d_otp d_tothip act_vp* act_otp* d_chvp d_otp* d_dt
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
order folio_efh year_efh, first
save "$path4b\\data_temp.dta", replace

replace dhip_vp=d_vp if dhip_vp==. & year_efh>=2014 
replace dhip_vp=d_chvp if dhip_vp==. & year_efh>=2014 
replace dhip_otp=d_otp if dhip_otp==. & year_efh>=2014
replace dhip=d_tothip if d_tothip==. & year_efh>=2014
egen d1=rowtotal(deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3)
replace dhip_otp=d1 if dhip_otp==.
egen d2=rowtotal(dhip_vp dhip_otp), missing
replace dhip=d2 if dhip==.
egen d3=rowtotal(dhip d_dna), missing
replace d_dt=d3 if d_dt==.
replace vp=act_vp if vp==. & year_efh>=2014
replace otp=act_otp if otp==. & year_efh>=2014
drop act_vp act_otp d_vp d_otp d1 d2 d3 d_tothip d_chvp c_vp c_otp  // last 2 are dummies
g deuda_hip_vp = dhip_vp  //rename dhip_vp deuda_hip_vp

sum folio_efh
joinby folio_efh year_efh using "$path4b\\HipReneg.dta", unmatched(both) update
tab _merge
drop _merge //fact* expr*
g year_q4=year_efh
joinby year_q4 using "$path4b\\UF_yr_q4.dta", unmatched(master) update
tab _merge
drop _merge year_q4
tab yrMatCMortg_vp
foreach Prop in "vp" "otp1" "otp2" "otp3" { 
replace yrMatCMortg_`Prop'=. if yrMatCMortg_`Prop'>70
}
foreach Prop in "vp" "otp1" "otp2" "otp3" { 
replace Ideuda_`Prop' = deuda_hip_`Prop' if Ideuda_`Prop'==. & deuda_hip_`Prop'>0 & deuda_hip_`Prop'<.
}
foreach Prop in "vp" "otp1" "otp2" "otp3" { //yrCMortg_vp yrCMortg_otp1 yrCMortg_otp2 yrCMortg_otp3
quietly replace yrCMortg_`Prop' = yrPurchase_`Prop' if yrCMortg_`Prop'==.
quietly replace yrCMortg_`Prop' = year_efh-20 if yrCMortg_`Prop'==. & Ideuda_`Prop'>0 & Ideuda_`Prop'<.
quietly replace mCMortg_`Prop' = 7 if mCMortg_`Prop'==. & yrCMortg_`Prop'<.
quietly replace yrMatCMortg_`Prop'=20 if yrMatCMortg_`Prop'==. & Ideuda_`Prop'>0 & Ideuda_`Prop'<.
g year = yrCMortg_`Prop'
g month = mCMortg_`Prop'
joinby year month using "$path4b\\TSuf.dta", unmatched(master) update
replace Id_`Prop'_tr=Id_`Prop'_tr*UFm if UFm>0 & UFm<.
replace Id_`Prop'_tr=Id_`Prop'_tr*uf if UFm==.
replace Ideuda_`Prop'=. if Ideuda_`Prop'==.
replace Ideuda_`Prop'=Id_`Prop'_tr if Ideuda_`Prop'==.
replace Ideuda_`Prop' = max(Ideuda_`Prop',deuda_hip_`Prop') if deuda_hip_`Prop'>0 & deuda_hip_`Prop'<.
g UFm_`Prop' = UFm
drop _merge Id_`Prop'_tr UFm
quietly replace yrCMortg_`Prop' = year_efh-20 if yrCMortg_`Prop'==. & Ideuda_`Prop'>0 & Ideuda_`Prop'<.  //
quietly replace yrMatCMortg_`Prop'=20 if yrMatCMortg_`Prop'==. & Ideuda_`Prop'>0 & Ideuda_`Prop'<.
quietly replace mCMortg_`Prop' = 7 if mCMortg_`Prop'==. & yrCMortg_`Prop'<.
replace year = yrCMortg_`Prop'
replace month = mCMortg_`Prop'
joinby year month using "$path4b\\TSuf.dta", unmatched(master) update
replace UFm_`Prop' = UFm if UFm_`Prop'==.
drop _merge  UFm    //
joinby year month using "$path4b\\TSRates.dta", unmatched(master) update
rename Rmortgage RCmortg_`Prop'   //tab _merge
drop _merge year month
replace UFm_`Prop' =uf if UFm_`Prop'==.   // Put original debts in UF
replace Ideuda_`Prop' = Ideuda_`Prop'/UFm_`Prop' 
}
save "$path4b\\HipReneg.dta", replace
