pr def lambert_w_integral
    args z nr_draws

quietly {

g step = _pi/(`nr_draws')
g Xa = uniform()
replace Xa = Xa*(_pi/`nr_draws')

forv nd=1/`nr_draws' {
g Lv = Xa + step*(`nd'-1)
lambert_w `z' Lv
rename Lw Lw_`nd'
drop Lv
}
egen LwI = rowtotal(Lw_*)
replace LwI = _pi*(`z'/_pi)*LwI*(1/`nr_draws')
drop Xa step Lw_*

}
end
