pr def refinance_PVgain
    args M taxtau I0 Mny_Gamma Inew

quietly {  // `nr_draws' must be a constant (choose 50, 100, 1000)
// variables: M is the real value of the mortgage debt; taxtau is the marginal tax rate of each observation (mortgage/household)
// Ka=npvK is the tax real cost of refinancing as a fixed NPV (see function refinance_npvKost.do for a formula)

refinance_npvKost ${Fcost} ${fpc} ${thetaADL} ${Nmyears} ${infR} `M' `taxtau'
refinance_Rlambda ${miuADL} `I0' `Mny_Gamma'
g xPVgain1 = ((1/(${rho}+Rlambda))*(`I0'-`Inew')*`M') - npvK/(1-`taxtau') // (npvK/`M')
drop npvK Rlambda
}
end
