local fD10="f3_1"
local fD11="f4"
forv yr=10/11 { // Create Debt and CF for each Bank  // `fD`yr''
use "$path0\\20`yr'\Data\Base_trabajo\EFH_`yr'_allvars.dta", clear
keep if a1==1
keep folio `fD`yr''* cf_* d_*
sum `fD`yr''*
capture drop f3_1e* 
capture drop f4_t9 f4_1e*
forv k=1/5 { // Each Debt Type replace unusual combinations of Debt and CF
	forv h=1/3 {  // Debt number 1 to 3
	replace d_`h'_td`k' = max(d_`h'_td`k', cf_`h'_td`k') if d_`h'_td`k'<. 
	sum cf_`h'_td`k' if d_`h'_td`k'>0 & cf_`h'_td`k'>0
	replace cf_`h'_td`k' = max(cf_`h'_td`k', r(min)) if d_`h'_td`k'>0 & d_`h'_td`k'<. 
	}
}      // // //
forv k1=1/21 { // Create Debt and CF for each Bank
g cf_B`k1' = 0
g d_B`k1' = 0
foreach k of numlist 1 2 4 { // Debt Type 1, 2 or 4 (Banks)
	forv h=1/3 {  // Debt number 1 to 3
	replace cf_B`k1' = cf_B`k1' + cf_`h'_td`k' if cf_`h'_td`k'<. & `fD`yr''_t`k'd`h'==`k1'
	replace d_B`k1' = d_B`k1' + max(d_`h'_td`k', cf_`h'_td`k') if d_`h'_td`k'<. & `fD`yr''_t`k'd`h'==`k1'
	}
} 
}
forv k1=1/10 { // Create Debt and CF for each Retail Store
g cf_R`k1' = 0
g d_R`k1' = 0
foreach k of numlist 3 5 { // Debt Type 3 or 5 (Retail)
	forv h=1/3 {  // Debt number 1 to 3
	replace cf_R`k1' = cf_R`k1' + cf_`h'_td`k' if cf_`h'_td`k'<. & `fD`yr''_t`k'd`h'==`k1'
	replace d_R`k1' = d_R`k1' + max(d_`h'_td`k', cf_`h'_td`k') if d_`h'_td`k'<. & `fD`yr''_t`k'd`h'==`k1'
	}
} 
}  
keep folio cf_B* d_B* cf_R* d_R*
g year_efh=20`yr'
rename folio folio_efh
save "$path4b\efh_`yr'_cbanks.dta", replace
}     
//       //     join  with 2014 and 2017
