foreach YS in "07" "08" "09" "10" "11" "14" "17" {  // 
local VLN_`YS' = ""
forv k=1/3 { 
local VL_Notp`k' = "yrPurchase_otp`k'_`YS' yrCMortg_otp`k'_`YS' mCMortg_otp`k'_`YS' yrMatCMortg_otp`k'_`YS' RenMortg_otp`k'_`YS' RenMotMortg_otp`k'_`YS'"
local VLN_`YS' = "`VLN_`YS'' `VL_Notp`k'_`YS''"
}
local VL_N_`YS' = "yrPurchase_vp_`YS' yrCMortg_vp_`YS' mCMortg_vp_`YS' yrMatCMortg_vp_`YS' RenMortg_vp_`YS' RenMotMortg_vp_`YS'"
local VLN_`YS' = "`VLN_17' `VL_N_`YS''" 
}
local VLN = ""
forv k=1/3 { 
local VL_Notp`k' = "yrPurchase_otp`k' yrCMortg_otp`k' mCMortg_otp`k' yrMatCMortg_otp`k' RenMortg_otp`k' RenMotMortg_otp`k'"
local VLN = "`VLN' `VL_Notp`k''"
}
local VL_N = "`VL_N' yrPurchase_vp yrCMortg_vp mCMortg_vp yrMatCMortg_vp RenMortg_vp RenMotMortg_vp"
local VLN = "`VLN' `VL_N'" 
local NVs = wordcount("`VLN'")

local VLO_17 = ""
forv k=1/3 { 
local yrPurchase_otp`k'_17 = "e49_ano_`k'"
local yrCMortg_otp`k'_17 = "e57_ano_`k'"
local mCMortg_otp`k'_17 = "e57_mes_`k'"
local yrMatCMortg_otp`k'_17 = "ptot_a_chotp_`k'"  // "e66_1" //plazohip_a_tp`k' (same, but ocasional negative numbers)
local RenMortg_otp`k'_17 = "e58_`k'" // 1 Si Renegoció, 2 No
local RenMotMortg_otp`k'_17 = "e60_`k'"
local VL_Ootp`k'_17 = "e49_ano_`k' e57_ano_`k' e57_mes_`k' ptot_a_chotp_`k' e58_`k' e60_`k'"
local VLO_17 = "`VLO_17' `VL_Ootp`k'_17'" 
}
local yrPurchase_vp_17 = "e7_ano"
local yrCMortg_vp_17 = "e20_ano"
local mCMortg_vp_17 = "e20_mes"
local yrMatCMortg_vp_17 = "ptot_a_chvp"   // = "e25" original maturity // maturity left to pay. plazohip_pp_m
local RenMortg_vp_17 = "e16" // 1 Si Renegoció, 2 No
local RenMotMortg_vp_17 = "e18"  // 1. Las tasas bajaron  2. Disminuir el dividendo aumentando el plazo  // 6. Otra.
// 3. Para hacer pre-pago y disminuir el plazo  4. Para hacer pre-pago y bajar dividendo 5. Para aumentar la deuda y usar el dinero para otros fines
local VL_O_17 = "e7_ano e20_ano e20_mes ptot_a_chvp e16 e18"
local VLO_17 = "`VLO_17' `VL_O_17'" 

use "$path0\2017\EFH_17_allvars.dta", clear
sum e7_* e16* e17* e18* e25* e26* e27* e32* e49* e58* e59* e60* e66* ptot_*ch* pp_m_*
capture drop a1
g a1=(ord==1)
g e20_ano=2017-e26_ano if e26_ano>=0
g e20_mes=mese-e26_mes if e26_mes>=1 & e26_mes<=12 & mese>=1 & mese<=12 // anoe mese
replace e20_ano=e20_ano-1 if e20_mes<=0
replace e20_mes=12+e20_mes if e20_mes<=0
replace e20_mes=mese if e20_mes==. & e20_ano<.
forv k=1/3 { 
g e57_ano_`k'=2017-e67_ano_`k' if e67_ano_`k'>=0
g e57_mes_`k'=mese-e67_mes_`k' if e67_mes_`k'>=1 & e67_mes_`k'<=12 & mese>=1 & mese<=12
replace e57_ano_`k'=e57_ano_`k'-1 if e57_mes_`k'<=0
replace e57_mes_`k'=12+e57_mes_`k' if e57_mes_`k'<=0
replace e20_mes=mese if e20_mes==. & e57_ano_`k'<.
}
capture drop a1
g a1=(ord==1)
g folio_efh=folio
g year_efh=2017
sum `VLO_17'
forv k=1/`NVs' { 
local x1=word("`VLO_17'",`k')
local x2=word("`VLN'",`k')
rename `x1' `x2'
}
sum `VLN'
keep if a1==1
sum `VLN'
forv k=1/3 { 
rename m_otp_fch_`k' deuda_hip_otp`k'
}  //rename m_vp_fch 
keep folio_efh year_efh  a1 `VLN' ${factor17} deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3 // e59_ano* e59_mes* e17_mes e17_ano
order folio_efh year_efh a1 ${factor17}, first
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace
