quietly {
use "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2010\Data\Base_trabajo\EFH_10_allvars.dta", clear
g EDF36=e13 // 2 (atrasos), 3 (no pagando)   // Vivienda Principal
g EDF37=e14 // cuantos meses de atraso
g EDF38=e15  // episodios de no pago en los ultimos 12 meses
replace EDF38=2 if e16<3
replace EDF38=2 if e16>=97 & e16<.
g e14_3 = (e11==1)
forv k2=1/3 {  // Otras propiedades
g EDF73_`k2' = e44_`k2' // 2 (atrasos), 3 (no pagando)
g EDF74_`k2' = e45_`k2'  // cuantos meses de atraso
g EDF75_`k2' = e46_`k2'   // episodios de no pago en los ultimos 12 meses
replace EDF75_`k2' = 2 if e47_`k2'<3
replace EDF75_`k2' = 2 if e47_`k2'>=97 & e47_`k2'<.
g e52_3_`k2' = (e42_`k2'==1)
}
*g df_vp = (EDF36==3) if e14_3==1 & a1==1  //e14_3 or e11 = pagó vivienda con crédito
*replace df_vp = (EDF37>=3 & EDF37<.) if e14_3==1 & a1==1 & EDF36==2 //replace df_vp = (EDF38==1) if e14_3==1 & a1==1 & df_vp==0
g df_vp = (EDF37>=3 & EDF37<.) if e14_3==1 & a1==1 //& EDF36==2
rename df_vp df_VPri
g df_VPri1M = (EDF37>=1 & EDF37<.) if e14_3==1 & a1==1 //& EDF36==2
replace df_VPri1M = 1 if e14_3==1 & a1==1 & EDF36==3
*replace df_VPri1M = 1 if e14_3==1 & a1==1 & EDF38==1
g df_vp = .
forv k=1/3 {
replace df_vp = 0 if df_vp==. & e52_3_`k'==1 
replace df_vp=1 if a1==1  & e52_3_`k'==1 & EDF74_`k'>=3 & EDF74_`k'<. // & EDF73_`k'==2 
*replace df_vp=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==3
*replace df_vp=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==2 & EDF74_`k'>=3 & EDF74_`k'<.  //replace df_vp=1 if a1==1  & EDF75_`k'==1 
}
rename df_vp df_VSec
g df_VSec1M = df_VSec
forv k=1/3 {
replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & EDF74_`k'>=1 & EDF74_`k'<. //& EDF73_`k'==2
replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==3
*replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==2 & EDF74_`k'>=1 & EDF74_`k'<. //replace dfVSec1M=1 if a1==1  & EDF75_`k'==1 
}
capture drop d_pcc //d_ccaf   // Banca retail, Banca No Retail, Banca Retail or Casa Comercial dummies
g d_br  =.
g d_bnr =.
g d_pcc =1  if f1_t5==1  // tiene p. casas com.
g d_ccaf=1   if f1_t7==1  // tiene CCAF o Coop.
g d_brpcc =1  if f1_t5==1 
forv k2=1/3 { // Si hogar tiene crédito en banca y p. casas com.
replace d_br   =1 if ((f3_1_t4d`k2'==15 | f3_1_t4d`k2'==16 | f3_1_t4d`k2'==18) & f3_1_t4d`k2'!=.)
replace d_bnr  =1 if ((f3_1_t4d`k2'!=15 | f3_1_t4d`k2'!=16 | f3_1_t4d`k2'!=18) & f3_1_t4d`k2'!=.)
replace d_brpcc=1 if (f1_t5==1) | ((f3_1_t4d`k2'==15 | f3_1_t4d`k2'==16 | f3_1_t4d`k2'==18) & f3_1_t4d`k2'!=.)
}
keep if a1==1
g act_tot = 0 + 0 + vp + otp + a_auto  //a_var + a_fijo
gen deuda_tot   = dhip_vp +dhip_otp +dtbco+ dtcc +dcbco+ dfin+ dauto +dsocial +deduc +dotros
gen rda=deuda_tot/max(1,act_tot)
rename act_tot act_totact
keep folio df_VP* df_VS* EDF36 EDF73_* d_br d_bnr d_brpcc d_pcc d_ccaf rda e3 act_totact
rename e3 Arriendo_pagado
g year=2010
save "$path4b\\data_temp.dta", replace

use "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2011\Data\Base_trabajo\EFH_11_allvars.dta", clear
g EDF36=e14
g EDF37=e15
g EDF38=e16
replace EDF38=2 if e17<3
replace EDF38=2 if e17>=97 & e17<.
g e14_3 = (e12==1)
forv k2=1/3 {
g EDF73_`k2' = e42_`k2'
g EDF74_`k2' = e43_`k2' 
g EDF75_`k2' = e44_`k2' 
replace EDF75_`k2' = 2 if e45_`k2'<3
replace EDF75_`k2' = 2 if e45_`k2'>=97 & e45_`k2'<.
g e52_3_`k2' = (e40_`k2'==1)
}
*g df_vp = (EDF36==3) if e14_3==1 & a1==1  //e14_3 or e11 = pagó vivienda con crédito
*replace df_vp = (EDF37>=3 & EDF37<.) if e14_3==1 & a1==1 & EDF36==2 //replace df_vp = (EDF38==1) if e14_3==1 & a1==1 & df_vp==0
g df_vp = (EDF37>=3 & EDF37<.) if e14_3==1 & a1==1 //& EDF36==2
rename df_vp df_VPri
g df_VPri1M = (EDF37>=1 & EDF37<.) if e14_3==1 & a1==1 //& EDF36==2
replace df_VPri1M = 1 if e14_3==1 & a1==1 & EDF36==3
*replace df_VPri1M = 1 if e14_3==1 & a1==1 & EDF38==1
g df_vp = .
forv k=1/3 {
replace df_vp = 0 if df_vp==. & e52_3_`k'==1 
replace df_vp=1 if a1==1  & e52_3_`k'==1 & EDF74_`k'>=3 & EDF74_`k'<. // & EDF73_`k'==2 
*replace df_vp=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==3
*replace df_vp=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==2 & EDF74_`k'>=3 & EDF74_`k'<.  //replace df_vp=1 if a1==1  & EDF75_`k'==1 
}
rename df_vp df_VSec
g df_VSec1M = df_VSec
forv k=1/3{
replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & EDF74_`k'>=1 & EDF74_`k'<. //& EDF73_`k'==2
replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==3
*replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==2 & EDF74_`k'>=1 & EDF74_`k'<. //replace dfVSec1M=1 if a1==1  & EDF75_`k'==1 
}
capture drop d_pcc //d_ccaf   // Banca retail, Banca No Retail, Banca Retail or Casa Comercial dummies
g d_br  =.
g d_bnr =.
g d_pcc =1  if f1_t5==1  // tiene p. casas com.
g d_ccaf=1   if f1_t7==1  // tiene CCAF o Coop.
g d_brpcc =1  if f1_t5==1 
forv k2=1/3 { // Si hogar tiene crédito en banca y p. casas com.
replace d_br   =1 if ((f4_t4d`k2'==15 | f4_t4d`k2'==16 | f4_t4d`k2'==18) & f4_t4d`k2'!=.)
replace d_bnr  =1 if ((f4_t4d`k2'!=15 | f4_t4d`k2'!=16 | f4_t4d`k2'!=18) & f4_t4d`k2'!=.)
replace d_brpcc=1 if (f1_t5==1) | ((f4_t4d`k2'==15 | f4_t4d`k2'==16 | f4_t4d`k2'==18) & f4_t4d`k2'!=.)
}
keep if a1==1
g act_tot = a_var + a_fijo + vp + otp + a_auto  
gen deuda_tot   = dhip_vp +dhip_otp +dtbco+ dtcc +dcbco+ dfin+ dauto +dsocial +deduc +dotros
gen rda=deuda_tot/max(1,act_tot)
rename act_tot act_totact
keep folio df_VP* df_VS* EDF36 EDF73_*  d_br d_bnr d_brpcc d_pcc d_ccaf rda e3 act_totact
rename e3 Arriendo_pagado
g year=2011
joinby year folio using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace

use "$path_bs_do\EFH_2014_08\EFH_14_allvars.dta", clear
capture drop a1
g EDF36=e36
forv k=1/3 {
g EDF73_`k'=e73_`k'
}
g a1=(ord==1)
*g df_vp = (e36==3) if e14_3==1 & a1==1
*replace df_vp = (e37>=3 & e37<.) if e14_3==1 & a1==1 & e36==2
*replace df_vp = (e38==1) if e14_3==1 & a1==1 & df_vp==0
g df_VPri = (e37>=3 & e37<.) if e14_3==1 & a1==1 //& e36==2
g df_VPri1M = (e37>=1 & e37<.) if e14_3==1 & a1==1 //& EDF36==2
replace df_VPri1M = 1 if e14_3==1 & a1==1 & e36==3
g df_vp = .
forv k=1/3 {
replace df_vp = 0 if df_vp==. & e52_3_`k'==1 
replace df_vp=1 if a1==1  & e52_3_`k'==1 & e74_`k'>=3 & e74_`k'<. //& e73_`k'==2 
*replace df_vp=1 if a1==1  & e52_3_`k'==1 & e73_`k'==3 //replace df_vp=1 if a1==1  & e75_`k'==1 
}
rename df_vp df_VSec
g df_VSec1M = df_VSec
forv k=1/3 {
replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & e74_`k'>=1 & e74_`k'<. //& e73_`k'==2 
replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & e73_`k'==3
*replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & e73_`k'==2 & e74_`k'>=1 & e74_`k'<. //replace dfVSec1M=1 if a1==1  & e75_`k'==1 
}
capture drop d_pcc //d_ccaf   // Banca retail, Banca No Retail, Banca Retail or Casa Comercial dummies
g d_br =.
g d_bnr =. 
g d_brpcc =1 if f1_t4==1  // tiene p. casas com.
g d_pcc =1   if f1_t4==1  // tiene p. casas com. 
g d_ccaf=1   if f1_t6==1  // tiene CCAF o Coop.
forv k2=1/3 { // Si hogar tiene crédito en banca y p. casas com.
replace d_br   =1 if ((f4_t5d`k2'==15 | f4_t5d`k2'==16 | f4_t5d`k2'==18) & f4_t5d`k2'!=.)
replace d_bnr  =1 if ((f4_t5d`k2'!=15 | f4_t5d`k2'!=16 | f4_t5d`k2'!=18) & f4_t5d`k2'!=.)
replace d_brpcc =1 if (f1_t4==1) | ((f4_t5d`k2'==15 | f4_t5d`k2'==16 | f4_t5d`k2'==18) & f4_t5d`k2'!=.)
}
forv i=1/3 {  // Categorias de hogares
g t_dotp_`i'=(t_chotp_`i'==1 | t_ccotp_`i'==1)
}  
// Inversionista inmobiliario
gen inv_inm1 =((e45==1) & (e48_1==4 | e48_2==4 | e48_3==4     |     e48_1==6 | e48_2==6 | e48_3==6     |     e48_1==9 | e48_2==9 | e48_3==9))
gen inv_inm2=((e45==1) & (((e48_1==4 | e48_1==6 | e48_1==9) & t_dotp_1==1) | ((e48_2==4 | e48_2==6 | e48_2==9) & t_dotp_2==1) | ((e48_3==4 | e48_3==6 | e48_3==9) & t_dotp_3==1)))
egen valor_vp=rowmax(e13 e15) // sum e5 e8 e7 e13 e15 e13_* e15_* if a1==1  recode e13_pe -2/-1=. recode e15_pe -2/-1=. pwcorr e13 e15 e13_* e15_* if a1==1
egen valor_2pr=rowmax(e50_pesos_*)
egen valor_2pr_0=rowmax(e50_uf_*)
egen year_q4=rowmax(e49_*)
replace year_q4=2014 if a1==1 & valor_2pr_0>0 & valor_2pr_0<. & year_q4==.
replace year_q4=2014 if a1==1 & valor_2pr_0>0 & valor_2pr_0<. & year_q4<0
joinby year_q4 using "$path4b\\\UF_yr_q4.dta", unmatched(master) update
tab _merge
replace valor_2pr_0=valor_2pr_0*max(uf_yrq4,7000)
replace valor_2pr=max(valor_2pr,valor_2pr_0)
drop _merge year_q4 uf_yrq4 valor_2pr_0
egen arriendo_2pr=rowtotal(e51_*)  // sum l5_13 if inv_inm1==1 & a1==1  sum l5_13 if inv_inm2==1 & a1==1
replace arriendo_2pr=max(arriendo_2pr,l5_13)
replace arriendo_2pr=. if arriendo_2pr<0
//   //   //
keep if a1==1
gen rda=(d_td1+d_td2 +d_td3 +d_td4 +d_td5 +d_td6 +d_td7 +d_td8 +d_tothip+d_dotras)/max(1,act_totact)
keep folio df_VP* df_VS* EDF36 EDF73_* d_br d_bnr d_brpcc d_pcc d_ccaf rda inv_inm1 inv_inm2 arriendo_2pr valor_vp valor_2pr ///
factor_egm estrato e5 act_totact 
rename e5 Arriendo_pagado
g year=2014
joinby year folio using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace

use "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2017\EFH_17_allvars.dta", clear
capture drop a1
capture drop a1
g EDF36=e29
forv k=1/3 {
g EDF73_`k'=e70_`k'
}
g a1=(ord==1)
*g df_vp = (e29==3) if e9_3==1 & a1==1 // Versión anterior //e36 e37 e38 (2014) e14_3
*replace df_vp = (e30>=3 & e30<.) if e9_3==1 & a1==1 & e29==2
*replace df_vp = (e31==1) if e9_3==1 & a1==1 & df_vp==0
g df_VPri = (e30>=3 & e30<.) if e9_3==1 & a1==1 //& e29==2
g df_VPri1M = (e30>=1 & e30<.) if e9_3==1 & a1==1 //& e29==2
replace df_VPri1M = 1 if e9_3==1 & a1==1 & e29==3
g df_vp = .
forv k=1/3{
replace df_vp = 0 if df_vp==. & e52_3_`k'==1 // Versión anterior //e36 (2014) e14_3 e73_ e74_ e75_
replace df_vp=1 if a1==1  & e52_3_`k'==1 & e71_`k'>=3 & e71_`k'<. //& e70_`k'==2 
*replace df_vp=1 if a1==1  & e52_3_`k'==1 & e70_`k'==3  //replace df_vp=1 if a1==1  & e72_`k'==1 
}
rename df_vp df_VSec
g df_VSec1M = df_VSec
forv k=1/3{
replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & e71_`k'>=1 & e71_`k'<. //& e70_`k'==2 
replace df_VSec1M=1 if a1==1  & e52_3_`k'==1 & e70_`k'==3
*replace df_vp=1 if a1==1  & e52_3_`k'==1 & e70_`k'==3  //replace df_vp=1 if a1==1  & e72_`k'==1 
}
capture drop d_pcc //d_ccaf  // Banca retail, Banca No Retail, Banca Retail or Casa Comercial dummies
g d_br  =.
g d_bnr =.
g d_brpcc = 1   if f1_t4==1  // tiene p. casas com.
g d_pcc =1   if f1_t4==1  // tiene p. casas com. 
g d_ccaf=1   if f1_t6==1  // tiene CCAF o Coop.
forv k2=1/3 {  //Si hogar tiene crédito en banca y p. casas com.
replace d_br   = 1 if ((f4_t5d`k2'==15 | f4_t5d`k2'==16 | f4_t5d`k2'==18) & f4_t5d`k2'!=.)
replace d_bnr = 1 if ((f4_t5d`k2'!=15 | f4_t5d`k2'!=16 | f4_t5d`k2'!=18) & f4_t5d`k2'!=.)
replace d_brpcc = 1 if (f1_t4==1) | ((f4_t5d`k2'==15 | f4_t5d`k2'==16 | f4_t5d`k2'==18) & f4_t5d`k2'!=.)
}
forv i=1/3 {  // Categorias de hogares
g t_dotp_`i'=(t_chotp_`i'==1 | t_ocotp_`i'==1 | t_faotp_`i'==1)
}   
// Inversionista inmobiliario
gen inv_inm1 =((e45==1) & (e48_1==4 | e48_2==4 | e48_3==4     |     e48_1==6 | e48_2==6 | e48_3==6     |     e48_1==9 | e48_2==9 | e48_3==9))
gen inv_inm2=((e45==1) & (((e48_1==4 | e48_1==6 | e48_1==9) & t_dotp_1==1) | ((e48_2==4 | e48_2==6 | e48_2==9) & t_dotp_2==1) | ((e48_3==4 | e48_3==6 | e48_3==9) & t_dotp_3==1)))
egen valor_vp=rowmax(e8 e10) // sum e5 e7_ano e6 e8 e10 e8_* e10_* if a1==1  recode e8_pe -2/-1=. recode e10_pe -2/-1=. pwcorr e8 e10 e8_* e10_* if a1==1
egen valor_2pr=rowmax(e50_pesos_*)
egen valor_2pr_0=rowmax(e50_uf_*)
egen year_q4=rowmax(e49_*)
replace year_q4=2017 if a1==1 & valor_2pr_0>0 & valor_2pr_0<. & year_q4==.
replace year_q4=2017 if a1==1 & valor_2pr_0>0 & valor_2pr_0<. & year_q4<0
joinby year_q4 using "$path4b\\\UF_yr_q4.dta", unmatched(master) update
tab _merge
replace valor_2pr_0=valor_2pr_0*max(uf_yrq4,7000)
replace valor_2pr=max(valor_2pr,valor_2pr_0)
drop _merge year_q4 uf_yrq4 valor_2pr_0
egen arriendo_2pr=rowtotal(e51_*)  // sum l5_14 if inv_inm1==1 & a1==1  sum l5_14 if inv_inm2==1 & a1==1
replace arriendo_2pr=max(arriendo_2pr,l5_14)
replace arriendo_2pr=. if arriendo_2pr<0
//   //   //   //    //
keep if a1==1
gen  rda=(d_td1+d_td2 +d_td3 +d_td4 +d_td5 +d_td6 +d_td7 +d_td8 +d_tothip+d_dotras)/max(1,act_totact)  
keep folio df_VP* df_VS* d_br d_bnr d_brpcc d_pcc d_ccaf EDF36 EDF73_* rda inv_inm1 inv_inm2 arriendo_2pr valor_vp valor_2pr ///
factor_egm estrato e5 act_totact
rename e5 Arriendo_pagado
g year=2017
joinby year folio using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace
}
replace Arriendo_pagado=. if Arriendo_pagado<=0
xtile Estrato_Arriendo=Arriendo_pagado [fw=factor_egm], nq(100)
recode Estrato_Arriendo 0/50=1 51/80=2 81/100=3 // Variable can also be created before 2014
g df_Vall = max(df_VPri,df_VSec)
g df_V1Mall = max(df_VPri1M,df_VSec1M)
egen Valor_PR=rowmax(valor_vp valor_2pr)
replace Valor_PR=Valor_PR*(26798/24431) if year==2014
xtile pc_hp=Valor_PR [fw=factor_egm], nq(100)  // Variable can also be created before 2014
sum Valor_PR if pc_hp<=50
g Estrato_VP=1 if valor_vp<=r(max)
g Estrato_2V=1 if valor_2pr<=r(max)
sum Valor_PR if pc_hp<=80
replace Estrato_VP=2 if valor_vp<=r(max) & Estrato_VP==.
replace Estrato_2V=2 if valor_2pr<=r(max) & Estrato_2V==.
sum Valor_PR if pc_hp<=100
replace Estrato_VP=3 if valor_vp<=r(max) & Estrato_VP==.
replace Estrato_2V=3 if valor_2pr<=r(max) & Estrato_2V==.
replace Estrato_VP=estrato if valor_vp>0 & valor_vp<. & Estrato_VP==.
replace Estrato_2V=estrato if valor_2pr>0 & valor_2pr<. & Estrato_2V==.
tab Estrato_VP [fw=factor_egm]
tab Estrato_2V [fw=factor_egm]
tab estrato [fw=factor_egm]
g vacancy_arriendo=(arriendo_2pr>0 & arriendo_2pr<.) if Estrato_2V<.
replace vacancy_arriendo=(vacancy_arriendo==0) if vacancy_arriendo<.
egen year_Estrato_2V=group(year Estrato_2V)
g a1=1
mean_wgts VacR_mE2V vacancy_arriendo year_Estrato_2V factor_egm   //bysort year Estrato_2V: sum vacancy_arriendo [fw=factor_egm]
bysort Estrato_2V: sum vacancy_arriendo VacR_mE2V [fw=factor_egm]
sum vacancy_arriendo VacR_mE2V  [fw=factor_egm]
bysort year: sum vacancy_arriendo VacR_mE2V [fw=factor_egm]
rename folio folio_efh 
drop factor_egm estrato a1 year_Estrato_2V
save "$path4b\\efh_DFVP_Ld.dta", replace
bysort year: sum df_VPri
replace df_VPri=1 if EDF36==3
bysort year: sum df_VPri
